//-----------------------------------
// protram to test the reading of
// music studio files
//-----------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "MSplay.h"
#include "bucket.h"

typedef struct {
	int n;
	char name[20];
}OBJ;

void PrintListBackwards(LIST *pList)
{
	OBJ *pO;
	BUCKET *pB = pList->pTail;
	pO = (OBJ *)(pB + 1);
	while(pO)
	{
		printf("OBJECT %d -> %s\n",pO->n,pO->name);
		pO = (OBJ *)prevBucket(pO);
	}
}

void PrintListForward(LIST *pList)
{
	OBJ *pO;
	BUCKET *pB = pList->pHead;
	pO = (OBJ *)(pB + 1);
	while(pO)
	{
		printf("OBJECT %d -> %s\n",pO->n,pO->name);
		pO = (OBJ *)nextBucket(pO);
	}
}

void TestBuckets()
{
	LIST *pList;
	OBJ *pO;
	int i;
	char *s = new char[256];

	printf("Test Buckets....Create List\n");
	pList = (LIST *)malloc(sizeof(LIST));
	pList->pHead = 0;
	pList->pTail = 0;
	for(i=0;i<20;++i)
	{
		pO = (OBJ *)newBucket(sizeof(OBJ));
		pO->n = i;
		sprintf(s,"OBJ %d",i);
		strcpy(pO->name,s);
		AddObject(pList,(void *)pO);
	}
	PrintListForward(pList);
	PrintListBackwards(pList);
	pO = (OBJ *)GetHead(pList);
	while(pO)
	{
		if(pO->n == 10)
		{
			delBucket(pList,(void *)pO);
			printf("Deleted %s\n",pO->name);
		}
		pO = (OBJ *)nextBucket(pO);
	}
	PrintListForward(pList);
	PrintListBackwards(pList);
	pO = (OBJ *)GetHead(pList);

	printf("Remove Head\n");
	delBucket(pList,(void *)pO);
	PrintListForward(pList);
	PrintListBackwards(pList);

	printf("Remove Tail\n");
	pO = (OBJ *)GetTail(pList);
	delBucket(pList,(void *)pO);
	PrintListForward(pList);
	PrintListBackwards(pList);
	delete[] s;
	exit(0);
}

int main(int argc, char *argv[])
{
	MSSONG *pSong=NULL;
	char *s = new char[1024];

	TestBuckets();
	printf("%s\n",argv[1]);
	InitMSplayer();
	pSong = LoadFile("prelude.sng",16);
	if(pSong)
	{
		GetSongParameters(pSong);
		StartSong(pSong);
		while(ticker(pSong));
		printf("Song->%s\n",pSong->SongName);
		sPrintTrkInfo(s,pSong);
		printf("%s",s);
	}
	delete[] s;
	return 0;
}